MaskCharacter:
  ld   c,2
  ld   b,24
  ld   a,(y)
  ld   l,a
  ld   a,(x)
  ld   ix,(MaskChar)
  call MaskSprite

  ld   c,2
  ld   b,24
  ld   a,(y)
  ld   l,a
  ld   a,(x)
  ld   ix,(MaskChar)
  ld   de,48
  add  ix,de
  call MaskSprite2
  ret

PutAlignedSprite:
    ld h,0
    ld d,h
    ld e,l
    add hl,hl
    add hl,de
    add hl,hl
    add hl,hl
    ld e,a
    add hl,de
    ld de,PlotsScreen
    add hl,de
    ex de,hl    ;de->screen buffer

    push ix
    pop hl      ;hl->sprite

    ld bc,(16*256)+12  ;b = 16, c = 12
DrawByte:
    push bc

    ldi         ;c = 11, hl++, de++
    ldi         ;c = 10, hl++, de++
    ld b,0      ;bc = 10
    ex de,hl
    add hl,bc	
    ex de,hl
    pop bc      ;restore b, c = 12
    djnz DrawByte
    ret

;-----> Draw a picture
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
MaskSprite:
	di
	ex	af,af'
	ld	a,c
	push	af
	ex	af,af'
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
MaskSpriteLoop1:
	push	hl
MaskSpriteLoop2:
	ld	d,(ix)
	ld	e,$FF
	ld	a,c
	or	a
	jr	z,MaskSpriteSkip1
MaskSpriteLoop3:
	scf
	rr	d
	rr	e
	dec	a
	jr	nz,MaskSpriteLoop3
MaskSpriteSkip1:
	ld	a,(hl)
	and	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	and	e
	ld	(hl),a
	inc	ix
	ex	af,af'
	dec	a
	push	af
	ex	af,af'
	pop	af
	jr	nz,MaskSpriteLoop2
	pop	hl
	pop	af
	push	af
	ex	af,af'
	ld	de,$0C
	add	hl,de
	djnz	MaskSpriteLoop1
	pop	af
	ret

;-----> Draw a picture
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
MaskSprite2:
	di
	ex	af,af'
	ld	a,c
	push	af
	ex	af,af'
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
MaskSprite2Loop1:
	push	hl
MaskSprite2Loop2:
	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,MaskSprite2Skip1
MaskSprite2Loop3:
	srl	d
	rr	e
	dec	a
	jr	nz,MaskSprite2Loop3
MaskSprite2Skip1:
	ld	a,(hl)
	or	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	or	e
	ld	(hl),a
	inc	ix
	ex	af,af'
	dec	a
	push	af
	ex	af,af'
	pop	af
	jr	nz,MaskSprite2Loop2
	pop	hl
	pop	af
	push	af
	ex	af,af'
	ld	de,$0C
	add	hl,de
	djnz	MaskSprite2Loop1
	pop	af
	ret